using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class CameraManager : MonoBehaviour
{
    public Prefab wall;
    public Image progressBar;
    public AudioClip Hit;

    private PlayersVenchile playersVenchile;
    private GameManager gameManager;

    private float tick = 0f;
    private int walls = 25;
    
    public void PlaySound(AudioClip sound)
    {
        audioSource.audioClip = sound;
        audioSource.Play();
    }

    public Vector3 GetGlobalMousePosition(float z = 0f)
	{
        Vector3 cursorPosition = Input.cursorPosition;
        float w = Screen.width;
        float h = Screen.height;

        float leftX = -8.885136f;
        float rightX = 8.885136f;
        float upY = -4.982978f;
        float downY = 4.982978f;

        float lenX = leftX - rightX;
        float lenY = upY - downY;

        return new Vector3(rightX + (lenX * (cursorPosition.x / w)), downY + (lenY * (cursorPosition.y / h)), z);
    }

    void Start()
    {
        playersVenchile = FindObjectOfType<PlayersVenchile>();
        gameManager = FindObjectOfType<GameManager>();
    }

    void Update()
    {
        progressBar.size = new Vector2((650 / 25) * walls, 20);
        tick += 1 * Time.deltaTime;
        if (tick >= 0.03f)
        {
            tick = 0f;
            Vector3 pos = GetGlobalMousePosition(5f);
            if (pos.x > 4.334349f & pos.x < 6.44871f & pos.y < 0.4679f & pos.y > -1.7237f & gameManager.gameStatus == "Starting")
            {
                if (Input.GetMouseButton(0) & walls > 0)
                {
                    walls -= 1;
                    GameObject w = wall.Instantiate(pos);
                    w.transform.parent = playersVenchile.transform;
                }
            }
        }
        
        if (Input.GetKeyDown(ScanCode.Escape))
        {
            FalcoEngine.Application.Quit();
        }
    }
}
