using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class EnemysWall : MonoBehaviour
{
    public int hp = 3;

    private PlayersSpear spear;
    private PlayersVenchile venchile;
    private CameraManager cameraManager;
    private bool attacked = false;

    float DistanceTo(Vector3 from)
    {
        return (float)Math.Pow(Math.Abs(Math.Pow(from.x - transform.position.x, 2f)) + Math.Abs(Math.Pow(from.y - transform.position.y, 2f)), 0.5f);
    }


    void Start()
    {
        spear = FindObjectOfType<PlayersSpear>();
        venchile = FindObjectOfType<PlayersVenchile>();
        cameraManager = FindObjectOfType<CameraManager>();
    }

    void Update()
    {
        if (DistanceTo(spear.transform.position) < 0.1f)
        {
            if (!attacked)
            {
                hp -= 1;
                cameraManager.PlaySound(cameraManager.Hit);
                venchile.rigidbody.linearVelocity = new Vector3(5f, venchile.rigidbody.linearVelocity.y, venchile.rigidbody.linearVelocity.z);
            }
            attacked = true;
        }
        else
        {
            attacked = false;
        }

        if (hp <= 0)
        {
            Destroy(gameObject);
        }
    }
}
