using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text.RegularExpressions;

public class GameManager : MonoBehaviour
{
	public Text statusText;
	public Image drawingZoneImage;
    public Image progressBar;
    public Button RestartButton;

    public string gameStatus = "Starting";

    private int currentLevel;


    void Start()
	{
        currentLevel = Convert.ToInt32(Regex.Replace(SceneManager.loadedScene, @"[^\d]+", ""));

        RestartButton.onMouseDown += (UIElement sender, int button, Vector2 cursorPosition) =>
        {
            SceneManager.LoadScene($"{currentLevel}.scene");
        };
    }
	
	void Update()
	{
		switch (gameStatus)
		{
			case "Starting":
				{
                    progressBar.gameObject.enabled = true;

                    statusText.text = "Draw a car and press S to start";
					if (Input.GetKeyDown(ScanCode.S))
					{
						gameStatus = "Processing";
						drawingZoneImage.gameObject.enabled = false;
					}
					break;
				}
            case "Processing":
                {
                    progressBar.gameObject.enabled = false;
                    statusText.text = "";
                    break;
                }
            case "Killed":
                {
                    statusText.text = "Press to restart";
                    if (Input.GetMouseButtonDown(0))
                        SceneManager.LoadScene($"{currentLevel}.scene");
                    break;
                }
            case "Finished":
                {
                    if (currentLevel != 10)
                    {
                        statusText.text = "Press for next level";
                        if (Input.GetMouseButtonDown(0))
                            SceneManager.LoadScene($"{currentLevel + 1}.scene");
                    }
                    else
                    {
                        statusText.text = "Thanks for playing! Press esc to quit";
                    }
                    
                    break;
                }

        }
	}
}
